VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4680
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   4680
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtYmax 
      Height          =   285
      Left            =   5640
      TabIndex        =   5
      Text            =   "7"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtYmin 
      Height          =   285
      Left            =   4920
      TabIndex        =   4
      Text            =   "-7"
      Top             =   240
      Width           =   615
   End
   Begin VB.PictureBox picGraph 
      AutoRedraw      =   -1  'True
      Height          =   3855
      Left            =   120
      ScaleHeight     =   3795
      ScaleWidth      =   7275
      TabIndex        =   11
      Top             =   720
      Width           =   7335
   End
   Begin VB.CommandButton cmdGraph 
      Caption         =   "Graph"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   10
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox txtXmax 
      Height          =   285
      Left            =   3360
      TabIndex        =   2
      Text            =   "10"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtXmin 
      Height          =   285
      Left            =   2640
      TabIndex        =   1
      Text            =   "-10"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtDx 
      Height          =   285
      Left            =   4080
      TabIndex        =   3
      Text            =   ".1"
      Top             =   240
      Width           =   495
   End
   Begin VB.TextBox txtExpression 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Text            =   "10*sin(x*2)/(x*x+1)"
      Top             =   240
      Width           =   2295
   End
   Begin VB.Label Label1 
      Caption         =   "Y min"
      Height          =   255
      Index           =   4
      Left            =   4920
      TabIndex        =   13
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Y max"
      Height          =   255
      Index           =   2
      Left            =   5640
      TabIndex        =   12
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "X min"
      Height          =   255
      Index           =   1
      Left            =   2640
      TabIndex        =   9
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "X max"
      Height          =   255
      Index           =   3
      Left            =   3360
      TabIndex        =   8
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Dx 
      Caption         =   "Dx"
      Height          =   255
      Index           =   2
      Left            =   4080
      TabIndex        =   7
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Expression"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Graph the equation entered by the user.
Private Sub cmdGraph_Click()
Dim xmin As Single
Dim xmax As Single
Dim Dx As Single
Dim ymin As Single
Dim ymax As Single
Dim x As Single
Dim y1 As Single
Dim y2 As Single
Dim i As Integer
Dim script_control As MSScriptControl.ScriptControl

    On Error GoTo EvaluateError

    ' Get the bounds.
    xmin = CSng(txtXmin.Text)
    xmax = CSng(txtXmax.Text)
    Dx = CSng(txtDx.Text)
    ymin = CSng(txtYmin.Text)
    ymax = CSng(txtYmax.Text)

    ' Scale to fit the bounds.
    picGraph.Scale (xmin, ymax)-(xmax, ymin)

    ' Draw the graph's background.
    picGraph.Cls
    picGraph.Line (xmin, 0)-(xmax, 0), vbBlue
    picGraph.Line (0, ymin)-(0, ymax), vbBlue
    For i = 0 To xmin Step -1
        picGraph.Line (i, -0.25)-Step(0, 0.5), vbRed
    Next i
    For i = 0 To xmax
        picGraph.Line (i, -0.25)-Step(0, 0.5), vbRed
    Next i
    For i = 0 To ymin Step -1
        picGraph.Line (-0.25, i)-Step(0.5, 0), vbRed
    Next i
    For i = 0 To ymax
        picGraph.Line (-0.25, i)-Step(0.5, 0), vbRed
    Next i

    ' Make a script control.
    Set script_control = New MSScriptControl.ScriptControl
    script_control.Language = "VBScript"

    ' Define the function.
    script_control.AddCode _
        "Function TheFunction(X)" & vbCrLf & _
        "    TheFunction = " & txtExpression.Text & vbCrLf & _
        "End Function"

    ' Graph the equation.
    y1 = script_control.Eval("TheFunction(" & xmin & ")")
    For x = xmin + Dx To xmax Step Dx
        ' Evaluate the next value.
        y2 = script_control.Eval("TheFunction(" & x & ")")

        ' Draw the next line.
        picGraph.Line (x - Dx, y1)-(x, y2)

        ' Save the current Y value.
        y1 = y2
    Next x
    Exit Sub

EvaluateError:
    Beep
    MsgBox Err.Description
End Sub
